import java.io.*;
import java.net.*;
import java.util.*;
import java.util.regex.*;
class lottery
{
	public lottery()
	{
	}

	public static void main(String [] args)
	{
		byte[] menuInput = new byte[1];
		byte[] longInput = new byte[1000];
		String s = "";
		int exit = 0;
		int fileCharacter, numCharsRead;
		int[] lottoNums = new int[53];
		int[] temp = new int[53];
		int[] winningNums = new int[6];
		int tempInt;
		int tempIntVal = 0;
		do
		{
			try
			{
				for(int i=0;i<5;i++)
					System.out.println("");
				System.out.println("Welcome to Jae's Lottery Prediction Program");
				System.out.println("What would you like to do?");
				System.out.println("1) Load results from file");
				System.out.println("2) Save results to file");
				System.out.println("3) Collect/add results from a URL");
				System.out.println("4) Enter results manually");
				System.out.println("5) Predict numbers (Least frequent numbers)");
				System.out.println("6) Predict numbers (Most frequent numbers)");
				System.out.println("7) Print currently loaded results");
				System.out.println("8) Exit");
				System.out.print(": ");
				numCharsRead = System.in.read(longInput);
				s = new String(longInput);
				switch((new Integer(s.substring(0,numCharsRead-1))).intValue())
				{
					case 1:
						for(int i=0;i<5;i++)
							System.out.println("");
						System.out.println("Load results from file");
						System.out.println("----------------------");
						try
						{
							System.out.print("Enter filename: ");
							numCharsRead = System.in.read(longInput);
							s = new String(longInput);
							FileReader r = new FileReader(s.substring(0,numCharsRead-1));
							int i = 0;
							fileCharacter = r.read();
							while(fileCharacter != -1)
							{
								lottoNums[i++] = fileCharacter;
								fileCharacter = r.read();
							}
							r.close();
						}
						catch (FileNotFoundException e)
						{
							System.out.println("Error: File not found");
						}
						break;
					case 2:
						for(int i=0;i<5;i++)
							System.out.println("");
						System.out.println("Save results to file");
						System.out.println("--------------------");
						try
						{
							System.out.print("Enter filename: ");
							numCharsRead = System.in.read(longInput);
							s = new String(longInput);
							File f = new File(s.substring(0,numCharsRead-1));
							FileWriter w = new FileWriter(f);
							for(int i=0;i<53;i++)
								w.write(lottoNums[i]);
							System.out.println("Attempting write");
							w.close();
						}
						catch(IOException e)
						{
							System.out.println("Error: Cannot write file");
						}	
						break;
					case 3:
						for(int i=0;i<5;i++)
							System.out.println("");
						System.out.println("Collect results from a URL");
						System.out.println("--------------------------");
						System.out.print("Enter URL: ");
						numCharsRead = System.in.read(longInput);
						s = new String(longInput);
						try
						{
							URL website = new URL(s.substring(0,numCharsRead-1));
							InputStream is = website.openStream();
							s = "";
							while(is.read(longInput) != -1)
								s = s + new String(longInput);
							String numbers;
							Pattern p = Pattern.compile("\\d\\d-\\d\\d-\\d\\d-\\d\\d-\\d\\d-\\d\\d");
							Matcher m = p.matcher(s);
							while(m.find())
							{
								numbers = m.group();
								++lottoNums[Integer.valueOf(numbers.substring(0,2)).intValue()-1];
								++lottoNums[Integer.valueOf(numbers.substring(3,5)).intValue()-1];
								++lottoNums[Integer.valueOf(numbers.substring(6,8)).intValue()-1];
								++lottoNums[Integer.valueOf(numbers.substring(9,11)).intValue()-1];
								++lottoNums[Integer.valueOf(numbers.substring(12,14)).intValue()-1];
								++lottoNums[Integer.valueOf(numbers.substring(15)).intValue()-1];
							}
						}
						catch(Exception e)
						{
							System.out.println("Error: Could not read from URL");
						}
						break;
					case 4:
						for(int i=0;i<5;i++)
							System.out.println("");
						System.out.println("Enter results manually");
						System.out.println("----------------------");
						System.out.print("Enter lotto number to add to current results: ");
						numCharsRead = System.in.read(longInput);
						s = new String(longInput);
						try
						{
						++lottoNums[Integer.valueOf(s.substring(0,numCharsRead-1)).intValue()-1];
						}
						catch(Exception e)
						{
							System.out.println("Could not read input");
						}
						break;
					case 5:
						for(int i=0;i<5;i++)
							System.out.println("");
						System.out.println("Predict numbers (Least frequent numbers)");
						System.out.println("----------------------------------------");
						System.out.print("Your \"winning\" numbers are: ");
						System.arraycopy(lottoNums,0,temp,0,53);
						tempIntVal = 0;
						for(int i=0;i<6;i++)
						{
							tempInt = 2147483647;
							for(int j=0;j<53;j++)
							{
								if(temp[j] < tempInt)
								{
									tempIntVal = j;
									tempInt = temp[j];
								}
							}
							winningNums[i] = tempIntVal;
							temp[tempIntVal] = 2147483647;
						}
						Arrays.sort(winningNums);
						for(int i=0;i<6;i++)
							System.out.print((winningNums[i]+1)+" ");
						break;
					case 6:
						for(int i=0;i<5;i++)
							System.out.println("");
						System.out.println("Predict numbers (Most frequent numbers)");
						System.out.println("----------------------------------------");
						System.out.print("Your \"winning\" numbers are: ");
						System.arraycopy(lottoNums,0,temp,0,53);
						tempIntVal = 0;
						for(int i=0;i<6;i++)
						{
							tempInt = -1;
							for(int j=0;j<53;j++)
							{
								if(temp[j] > tempInt)
								{
									tempIntVal = j;
									tempInt = temp[j];
								}
							}
							winningNums[i] = tempIntVal;
							temp[tempIntVal] = -1;
						}
						Arrays.sort(winningNums);
						for(int i=0;i<6;i++)
							System.out.print((winningNums[i]+1)+" ");
						break;
					case 7:
						for(int i=0;i<5;i++)
							System.out.println("");
						System.out.println("Print currently loaded results");
						System.out.println("------------------------------");
						System.out.print("Number:  ");
						for(int i=1;i<=9;i++)
							System.out.print(i+"    ");
						for(int i=10;i<=20;i++)
							System.out.print(i+"   ");
						System.out.println("");
						System.out.print("Results: ");
						for(int i=1;i<=20;i++)
						{
							if(lottoNums[i-1]<10)
								System.out.print(lottoNums[i-1]+"    ");
							else if(lottoNums[i-1]<100)
								System.out.print(lottoNums[i-1]+"   ");
							else
								System.out.print(lottoNums[i-1]+"  ");
						}
						System.out.println("");
						System.out.println("");
						System.out.print("Number:  ");
						for(int i=21;i<=40;i++)
							System.out.print(i+"   ");
						System.out.println("");
						System.out.print("Results: ");
						for(int i=21;i<=40;i++)
						{
							if(lottoNums[i-1]<10)
								System.out.print(lottoNums[i-1]+"    ");
							else if(lottoNums[i-1]<100)
								System.out.print(lottoNums[i-1]+"   ");
							else
								System.out.print(lottoNums[i-1]+"  ");
						}
						System.out.println("");
						System.out.println("");
						System.out.print("Number:  ");
						for(int i=41;i<=53;i++)
							System.out.print(i+"   ");
						System.out.println("");
						System.out.print("Results: ");
						for(int i=41;i<=53;i++)
						{
							if(lottoNums[i-1]<10)
								System.out.print(lottoNums[i-1]+"    ");
							else if(lottoNums[i-1]<100)
								System.out.print(lottoNums[i-1]+"   ");
							else
								System.out.print(lottoNums[i-1]+"  ");
						}
						break;	
					case 8:
						System.out.println("Exiting");
						exit = 1;
						break;
					default:
						System.out.println("invalid input");
						break;
				}
			}
			catch(Exception e)
			{
			}
		} while (exit == 0);
	}
}
